Codeforces978F. Mentors(二分)

F. Mentors

time limit per test

3 seconds

memory limit per test

256 megabytes

input

standard input

output

standard output

In BerSoft nn programmers work, the programmer ii is characterized by a skill riri.

A programmer aa can be a mentor of a programmer bb if and only if the skill of the programmer aa is strictly greater than the skill of the programmer bb (ra>rb)(ra>rb) and programmers aa and bb are not in a quarrel.

You are given the skills of each programmers and a list of kk pairs of the programmers, which are in a quarrel (pairs are unordered). For each programmer ii, find the number of programmers, for which the programmer ii can be a mentor.

Input

The first line contains two integers nn and kk (2≤n≤2⋅105(2≤n≤2⋅105, 0≤k≤min(2⋅105,n⋅(n−1)2))0≤k≤min(2⋅105,n⋅(n−1)2)) — total number of programmers and number of pairs of programmers which are in a quarrel.

The second line contains a sequence of integers r1,r2,…,rnr1,r2,…,rn (1≤ri≤109)(1≤ri≤109), where riri equals to the skill of the ii-th programmer.

Each of the following kk lines contains two distinct integers xx, yy (1≤x,y≤n(1≤x,y≤n, x≠y)x≠y) — pair of programmers in a quarrel. The pairs are unordered, it means that if xx is in a quarrel with yy then yy is in a quarrel with xx. Guaranteed, that for each pair (x,y)(x,y) there are no other pairs (x,y)(x,y) and (y,x)(y,x) in the input.

Output

Print nn integers, the ii-th number should be equal to the number of programmers, for which the ii-th programmer can be a mentor. Programmers are numbered in the same order that their skills are given in the input.

Examples

input

Copy

4 2
10 4 10 15
1 2
4 3

output

Copy

0 0 1 2 

input

Copy

10 4
5 4 1 5 4 3 7 1 2 5
4 6
2 1
10 8
3 5

output

Copy

5 4 0 5 3 3 9 0 2 5 

Note

In the first example, the first programmer can not be mentor of any other (because only the second programmer has a skill, lower than first programmer skill, but they are in a quarrel). The second programmer can not be mentor of any other programmer, because his skill is minimal among others. The third programmer can be a mentor of the second programmer. The fourth programmer can be a mentor of the first and of the second programmers. He can not be a mentor of the third programmer, because they are in a quarrel.

 

一、原题地址

点我传送

 

二、大致题意

    给出n个数,表示n个人各自的水平值,水平值高的人可以成为水平低的人的导师。同时给出m组数,表示编号为i 、j的人正处于争吵,他们无法成为各自的导师。求每个人能成为多少个人的导师。

 

三、思路

    将所有人的水平值先排序,二分每个人的水平在这堆人处于什么位置。同时在读入m对争吵的关系时处理,将这两个争吵的人中水平高的人的度数+1。这样我们可以得到每个人对应的答案应该为:在数组中的排名减去这个人对应的度数。

 

四、代码

 

#include<iostream>
#include<cstdio>
#include<cstdlib>
#include<cstring>
#include<cmath>
#include<string>
#include<algorithm>
#include<vector>
#include<queue>
#include<set>
#include<map>
#include<stack>
using namespace std;
const int inf=0x3f3f3f3f;


int n,m;
struct Node 
{
	int skill,id;
}a[300005],b[300005];
int indree[300005];
bool cmp(Node xx,Node yy)
{
	if(xx.skill!=yy.skill)
		return xx.skill<yy.skill;
	else
		return xx.id<yy.id;
}
int main()
{
	memset(indree,0,sizeof(indree));
	scanf("%d%d",&n,&m);
	for(int i=0;i<n;i++)
	{
		scanf("%d",&a[i].skill);
		a[i].id=i;
		b[i]=a[i];
	}
	int x,y;
	for(int i=0;i<m;i++)
	{
		scanf("%d%d",&x,&y);
		x--,y--;
		if(a[x].skill<a[y].skill)
			indree[y]++;
		else if(a[x].skill>a[y].skill)
			indree[x]++;
	}
	sort(b,b+n,cmp);
	for(int i=0;i<n;i++)
	{
		int t=a[i].skill;
		int l=0,r=n-1;
		int mid=0;
		while(l<=r)
		{
			mid=(l+r)/2;
			if(b[mid].skill<t)l=mid+1;
			else if(b[mid].skill>=t)r=mid-1;
		}
		int ans=(r+1)-indree[a[i].id];
		printf("%d ",ans);
	}
	getchar();
	getchar();
}

 

 

 

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 1
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论 1
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值